/**
 *******************************************************************************
 * @file  system_RIN32M3.h
 * @brief sample program for R-IN32M3
 * 
 * @note 
 * Copyright (C) 2011-2013 Renesas Electronics Corporation 
 * Copyright (C) 2011-2013 Renesas Micro Systems Co., Ltd. 
 * 
 * @par
 *  This is a sample program. 
 *  Renesas Electronics assumes no responsibility for any losses incurred. 
 * 
 *******************************************************************************
 */
#ifndef __SYSTEM_RIN32M3_H
#define __SYSTEM_RIN32M3_H

#ifdef __cplusplus
extern "C" {
#endif

/*==========================================================================*/
/* I N C L U D E															*/
/*==========================================================================*/
#if defined ( __ICCARM__ )
#include <arm_itm.h>
#endif

/*==========================================================================*/
/* T Y P E D E F															*/
/*==========================================================================*/

/*==========================================================================*/
/* D E F I N E																*/
/*==========================================================================*/
#define RIN32M3_SYSCLK	100000000			/* System clock freq.(Hz) */
#define SYS_UART_CH		1					/* UART channel           */

/*==========================================================================*/
/* E X T E R N																*/
/*==========================================================================*/
extern uint32_t SystemCoreClock;

extern void SystemInit(void);

extern void SystemCoreClockUpdate(void);

#ifdef __cplusplus
}
#endif

#else
#endif
