/***********************************************************************/
/*  FlashDev.c:  Device Description for                                */
/*               Renesas R-IN32M3 Device and                           */
/*               Spansion S29AL032D External NOR Flash  (16-bit Bus)   */
/*                                                                     */
/***********************************************************************/

#include "..\FlashOS.H"        // FlashOS Structures


struct FlashDevice const FlashDevice  =  {
   FLASH_DRV_VERS,             // Driver Version, do not modify!
   "R-IN32M3 S29AL032D Flash", // Device Name
   EXT16BIT,                   // Device Type
   0x10000000,                 // Device Start Address
   0x00400000,                 // Device Size in Bytes (32Mbit=4MByte)
   512,                        // Programming Page Size (512-byte page size)
   0,                          // Reserved, must be 0
   0xFF,                       // Initial Content of Erased Memory
   300,                        // Program Page Timeout 300 mSec
   3000,                       // Erase Sector Timeout 3000 mSec

// Specify Size and Address of Sectors
   0x02000, 0x000000,          // Sector Size  8kB (8 Sectors) 
   0x10000, 0x010000,          // Sector Size 64kB (63 Sectors)
   SECTOR_END
};
